Leetcode-Java(二十二)

weixin_33976072發表於2018-06-11

211. Add and Search Word - Data structure design

4155986-a27f438d5622931c.png

建立一棵字典樹,特別注意.的情況。

public class WordDictionary {
    public class TrieNode {
        public TrieNode[] children = new TrieNode[26];
        public String item = "";
    }
    
    private TrieNode root = new TrieNode();

    public void addWord(String word) {
        TrieNode node = root;
        for (char c : word.toCharArray()) {
            if (node.children[c - 'a'] == null) {
                node.children[c - 'a'] = new TrieNode();
            }
            node = node.children[c - 'a'];
        }
        node.item = word;
    }

    public boolean search(String word) {
        return match(word.toCharArray(), 0, root);
    }
    
    private boolean match(char[] chs, int k, TrieNode node) {
        if (k == chs.length) return !node.item.equals("");   
        if (chs[k] != '.') {
            return node.children[chs[k] - 'a'] != null && match(chs, k + 1, node.children[chs[k] - 'a']);
        } else {
            for (int i = 0; i < node.children.length; i++) {
                if (node.children[i] != null) {
                    if (match(chs, k + 1, node.children[i])) {
                        return true;
                    }
                }
            }
        }
        return false;
    }
}

213. House Robber II

4155986-601970a699820c4a.png

分兩種情況遍歷兩遍陣列即可,第一遍是可以偷第一個,不能偷最後一個,第二遍時可以偷最後一個,不能偷第一個。

class Solution {
    public int rob(int[] nums) {
        int res = 0;
        if(nums == null || nums.length==0)
            return res;
        if(nums.length==1)
            return nums[0];
        if(nums.length==2)
            return Math.max(nums[0],nums[1]);
        
        int[] temp = new int[nums.length-1];
        temp[0] = nums[0];
        temp[1] = Math.max(nums[0],nums[1]);
        for(int i=2;i<nums.length-1;i++){
            temp[i] = Math.max(nums[i] + temp[i-2],temp[i-1]);
        }
        res = temp[nums.length-2];
        temp[0] = nums[1];
        temp[1] = Math.max(nums[1],nums[2]);
        for(int i=3;i<nums.length;i++){
            temp[i-1] = Math.max(nums[i] + temp[i-3],temp[i-2]);
        }
        res = Math.max(res,temp[nums.length-2]);
        return res;
    }
}

215. Kth Largest Element in an Array

4155986-75ed616a9043194d.png

如果求第K大的元素,那麼要構建的是小頂堆。求第K小的元素,那麼要構建大頂堆!先構建k個元素的堆,另外i-k個元素逐個跟堆頂元素比較,如果比堆頂元素小,那麼就將該元素納入堆中,並保持堆的性質。

當然這裡只是為了複習一下堆排序所以用了這個方法,還有很多方法比如快速排序等都可以使用。

class Solution {
    public int findKthLargest(int[] nums, int k) {
        heapSort(nums,k);
        return nums[0];
    }
    
    public static void heapSort(int[] nums,int k){
        for(int i=k/2;i>=0;i--){
            perceDown(nums,i,k);
        }
        System.out.println(nums[0]);
        for(int i=k;i<nums.length;i++){
            if (nums[i] <= nums[0])
                continue;
            else{
                nums[0] = nums[I];
                perceDown(nums,0,k);
                
            }       
        }
    }
    
    public static void perceDown(int[] nums,int index,int k){
        int temp = nums[index];
        int child = 2 * index + 1;
        while(child < k){
            if(child + 1 < k && nums[child+1] < nums[child])
                child = child + 1;
            if(temp >nums[child]){
                nums[index] = nums[child];
                index= child;  
                child = 2 * index + 1;
            }
            else
                break;
        }
        nums[index] = temp;
    }
}

216. Combination Sum III

4155986-45ac948eba658212.png

回溯法的使用,這裡犯了一個小錯誤,Arraylist remove刪除的是對應索引位置的元素,而不是刪除指定值的元素。

class Solution {
    public List<List<Integer>> res;
    public List<List<Integer>> combinationSum3(int k, int n) {
        res = new ArrayList<List<Integer>>();
        backpop(1,k,n,new ArrayList<Integer>());
        return res;
    }
    
    public void backpop(int start,int k,int n,List<Integer> single){
        if(n==0 && k==0){
            res.add(new ArrayList<Integer>(single));
            return;
        }
        if(n < start)
            return;
        for(int i=start;i<=9;i++){
            single.add(i);
            backpop(i+1,k-1,n-i,single);
            single.remove(single.size()-1);
        }
    }
}

217. Contains Duplicate

4155986-a489cb5208c0fdd1.png

使用一個Hashset即可,可以節省空間

class Solution {
    public boolean containsDuplicate(int[] nums) {
        Set<Integer> set = new HashSet<Integer>();
        for(int num:nums){
            if(!set.contains(num))
                set.add(num);
            else
                return true;
        }
        return false;
    }
}

219. Contains Duplicate II

4155986-a4597da4ec2f8ef6.png

由於涉及到位置資訊,所以這次用Map儲存。

class Solution {
    public boolean containsNearbyDuplicate(int[] nums, int k) {
        Map<Integer,Integer> map = new HashMap<Integer,Integer>();
        for(int i=0;i<nums.length;i++){
            if(!map.containsKey(nums[I]))
                map.put(nums[i],i);
            else{
                if ((i - map.get(nums[i])) <= k)
                    return true;
                map.put(nums[i],i);
            }
        }
        return false;
    }
}

220. Contains Duplicate III

4155986-c60c1bedf5e50552.png

這道題使用到了java中的TreeSet,有關TreeSet,我們後面會詳細介紹,這裡貼一個連結已備查:https://blog.csdn.net/thinking2013/article/details/46336373

class Solution {
    public boolean containsNearbyAlmostDuplicate(int[] nums, int k, int t) {
        TreeSet<Long> ts = new TreeSet<Long>();
        for(int i=0;i<nums.length;i++){
            if(i-k-1>=0)
                ts.remove((long)nums[i-k-1]);
            //返回此 set 中大於等於給定元素的最小元素;如果不存在這樣的元素,則返回 null。
            Long tmp = ts.ceiling((long)nums[I]);
            if(tmp != null && t>=Math.abs(tmp-nums[i])) return true;
            //返回此 set 中小於等於給定元素的最大元素;如果不存在這樣的元素,則返回 null。
            tmp = ts.floor((long)nums[I]);
            if(tmp!=null && t>= Math.abs(nums[i] - tmp)) return true;
            ts.add((long)nums[i]);    
        }
        return false;
    }
}

相關文章